
_set_up:

;Exp3.c,7 :: 		void set_up() {   //Configuration for Pic16F887
;Exp3.c,9 :: 		ANSEL = 0x04;     // RRA2 analog input
	MOVLW      4
	MOVWF      ANSEL+0
;Exp3.c,10 :: 		ANSELH = 0;      // Rest of the pins set as digital inputs or outputs.
	CLRF       ANSELH+0
;Exp3.c,11 :: 		TRISA = 0x04;
	MOVLW      4
	MOVWF      TRISA+0
;Exp3.c,12 :: 		ADCON0 = 0x81;  // ADC_clock period = 4us, CH0, GO_DONE = 0 and ADON = 1
	MOVLW      129
	MOVWF      ADCON0+0
;Exp3.c,13 :: 		ADFM_bit= 1;  // Conversion result is right justified
	BSF        ADFM_bit+0, BitPos(ADFM_bit+0)
;Exp3.c,14 :: 		C1ON_bit = 0;    // analog comparators off.
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;Exp3.c,15 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;Exp3.c,16 :: 		TRISC2_bit= 0;
	BCF        TRISC2_bit+0, BitPos(TRISC2_bit+0)
;Exp3.c,17 :: 		RC2_bit = 0;
	BCF        RC2_bit+0, BitPos(RC2_bit+0)
;Exp3.c,18 :: 		}
L_end_set_up:
	RETURN
; end of _set_up

_PWM_Write:

;Exp3.c,20 :: 		PWM_Write(unsigned int duty, long PWM_freq) {
;Exp3.c,22 :: 		if(duty<1023)  {
	MOVLW      3
	SUBWF      FARG_PWM_Write_duty+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__PWM_Write7
	MOVLW      255
	SUBWF      FARG_PWM_Write_duty+0, 0
L__PWM_Write7:
	BTFSC      STATUS+0, 0
	GOTO       L_PWM_Write0
;Exp3.c,23 :: 		duty = ((float)duty/1023)*(XFREQ/(PWM_freq*T2_Pscale));
	MOVF       FARG_PWM_Write_duty+0, 0
	MOVWF      R0+0
	MOVF       FARG_PWM_Write_duty+1, 0
	MOVWF      R0+1
	CALL       _word2double+0
	MOVLW      0
	MOVWF      R4+0
	MOVLW      192
	MOVWF      R4+1
	MOVLW      127
	MOVWF      R4+2
	MOVLW      136
	MOVWF      R4+3
	CALL       _Div_32x32_FP+0
	MOVF       R0+0, 0
	MOVWF      FLOC__PWM_Write+0
	MOVF       R0+1, 0
	MOVWF      FLOC__PWM_Write+1
	MOVF       R0+2, 0
	MOVWF      FLOC__PWM_Write+2
	MOVF       R0+3, 0
	MOVWF      FLOC__PWM_Write+3
	MOVF       FARG_PWM_Write_PWM_freq+0, 0
	MOVWF      R4+0
	MOVF       FARG_PWM_Write_PWM_freq+1, 0
	MOVWF      R4+1
	MOVF       FARG_PWM_Write_PWM_freq+2, 0
	MOVWF      R4+2
	MOVF       FARG_PWM_Write_PWM_freq+3, 0
	MOVWF      R4+3
	RLF        R4+0, 1
	RLF        R4+1, 1
	RLF        R4+2, 1
	RLF        R4+3, 1
	BCF        R4+0, 0
	RLF        R4+0, 1
	RLF        R4+1, 1
	RLF        R4+2, 1
	RLF        R4+3, 1
	BCF        R4+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVLW      18
	MOVWF      R0+1
	MOVLW      122
	MOVWF      R0+2
	MOVLW      0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
	CALL       _longint2double+0
	MOVF       FLOC__PWM_Write+0, 0
	MOVWF      R4+0
	MOVF       FLOC__PWM_Write+1, 0
	MOVWF      R4+1
	MOVF       FLOC__PWM_Write+2, 0
	MOVWF      R4+2
	MOVF       FLOC__PWM_Write+3, 0
	MOVWF      R4+3
	CALL       _Mul_32x32_FP+0
	CALL       _double2word+0
	MOVF       R0+0, 0
	MOVWF      FARG_PWM_Write_duty+0
	MOVF       R0+1, 0
	MOVWF      FARG_PWM_Write_duty+1
;Exp3.c,25 :: 		DC1B1_bit = duty & 1; //Store the 1st bit
	MOVLW      1
	ANDWF      R0+0, 0
	MOVWF      R2+0
	BTFSC      R2+0, 0
	GOTO       L__PWM_Write8
	BCF        DC1B1_bit+0, BitPos(DC1B1_bit+0)
	GOTO       L__PWM_Write9
L__PWM_Write8:
	BSF        DC1B1_bit+0, BitPos(DC1B1_bit+0)
L__PWM_Write9:
;Exp3.c,26 :: 		DC1B0_bit = duty & 2; //Store the 0th bit
	MOVLW      2
	ANDWF      R0+0, 0
	MOVWF      R2+0
	BTFSC      R2+0, 0
	GOTO       L__PWM_Write10
	BCF        DC1B0_bit+0, BitPos(DC1B0_bit+0)
	GOTO       L__PWM_Write11
L__PWM_Write10:
	BSF        DC1B0_bit+0, BitPos(DC1B0_bit+0)
L__PWM_Write11:
;Exp3.c,27 :: 		CCPR1L = duty>>2;// Store the remining 8 bit
	MOVF       R0+0, 0
	MOVWF      R2+0
	MOVF       R0+1, 0
	MOVWF      R2+1
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	RRF        R2+1, 1
	RRF        R2+0, 1
	BCF        R2+1, 7
	MOVF       R2+0, 0
	MOVWF      CCPR1L+0
;Exp3.c,28 :: 		}
L_PWM_Write0:
;Exp3.c,29 :: 		}
L_end_PWM_Write:
	RETURN
; end of _PWM_Write

_PWM_Init:

;Exp3.c,31 :: 		PWM_Init(long PWM_freq) {
;Exp3.c,33 :: 		PR2 = (XFREQ/(PWM_freq*4*T2_Pscale)) - 1;
	MOVF       FARG_PWM_Init_PWM_freq+0, 0
	MOVWF      R8+0
	MOVF       FARG_PWM_Init_PWM_freq+1, 0
	MOVWF      R8+1
	MOVF       FARG_PWM_Init_PWM_freq+2, 0
	MOVWF      R8+2
	MOVF       FARG_PWM_Init_PWM_freq+3, 0
	MOVWF      R8+3
	RLF        R8+0, 1
	RLF        R8+1, 1
	RLF        R8+2, 1
	RLF        R8+3, 1
	BCF        R8+0, 0
	RLF        R8+0, 1
	RLF        R8+1, 1
	RLF        R8+2, 1
	RLF        R8+3, 1
	BCF        R8+0, 0
	MOVF       R8+0, 0
	MOVWF      R4+0
	MOVF       R8+1, 0
	MOVWF      R4+1
	MOVF       R8+2, 0
	MOVWF      R4+2
	MOVF       R8+3, 0
	MOVWF      R4+3
	RLF        R4+0, 1
	RLF        R4+1, 1
	RLF        R4+2, 1
	RLF        R4+3, 1
	BCF        R4+0, 0
	RLF        R4+0, 1
	RLF        R4+1, 1
	RLF        R4+2, 1
	RLF        R4+3, 1
	BCF        R4+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVLW      18
	MOVWF      R0+1
	MOVLW      122
	MOVWF      R0+2
	MOVLW      0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
	DECF       R0+0, 0
	MOVWF      PR2+0
;Exp3.c,35 :: 		CCP1M3_bit = 1;
	BSF        CCP1M3_bit+0, BitPos(CCP1M3_bit+0)
;Exp3.c,36 :: 		CCP1M2_bit = 1;  //Configure the CCP1 module
	BSF        CCP1M2_bit+0, BitPos(CCP1M2_bit+0)
;Exp3.c,37 :: 		T2CKPS0_bit = 1;
	BSF        T2CKPS0_bit+0, BitPos(T2CKPS0_bit+0)
;Exp3.c,38 :: 		T2CKPS1_bit = 0;
	BCF        T2CKPS1_bit+0, BitPos(T2CKPS1_bit+0)
;Exp3.c,39 :: 		TMR2ON_bit = 1; //Configure the Timer module
	BSF        TMR2ON_bit+0, BitPos(TMR2ON_bit+0)
;Exp3.c,40 :: 		TRISC2_bit = 0; // make port pin on C as output
	BCF        TRISC2_bit+0, BitPos(TRISC2_bit+0)
;Exp3.c,41 :: 		}
L_end_PWM_Init:
	RETURN
; end of _PWM_Init

_main:

;Exp3.c,42 :: 		void main() {
;Exp3.c,43 :: 		set_up();
	CALL       _set_up+0
;Exp3.c,44 :: 		PWM_Init(5000);
	MOVLW      136
	MOVWF      FARG_PWM_Init_PWM_freq+0
	MOVLW      19
	MOVWF      FARG_PWM_Init_PWM_freq+1
	CLRF       FARG_PWM_Init_PWM_freq+2
	CLRF       FARG_PWM_Init_PWM_freq+3
	CALL       _PWM_Init+0
;Exp3.c,45 :: 		while (1) {
L_main1:
;Exp3.c,46 :: 		adc_rd = ADC_Read(2);
	MOVLW      2
	MOVWF      FARG_ADC_Read_channel+0
	CALL       _ADC_Read+0
	MOVF       R0+0, 0
	MOVWF      _adc_rd+0
	MOVF       R0+1, 0
	MOVWF      _adc_rd+1
;Exp3.c,47 :: 		delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_main3:
	DECFSZ     R13+0, 1
	GOTO       L_main3
	DECFSZ     R12+0, 1
	GOTO       L_main3
	NOP
	NOP
;Exp3.c,48 :: 		PWM_Write((adc_rd),5000);
	MOVF       _adc_rd+0, 0
	MOVWF      FARG_PWM_Write_duty+0
	MOVF       _adc_rd+1, 0
	MOVWF      FARG_PWM_Write_duty+1
	MOVLW      136
	MOVWF      FARG_PWM_Write_PWM_freq+0
	MOVLW      19
	MOVWF      FARG_PWM_Write_PWM_freq+1
	CLRF       FARG_PWM_Write_PWM_freq+2
	CLRF       FARG_PWM_Write_PWM_freq+3
	CALL       _PWM_Write+0
;Exp3.c,49 :: 		delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_main4:
	DECFSZ     R13+0, 1
	GOTO       L_main4
	DECFSZ     R12+0, 1
	GOTO       L_main4
	NOP
	NOP
;Exp3.c,50 :: 		}
	GOTO       L_main1
;Exp3.c,51 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
