
#define XFREQ 8000000
#define T2_Pscale 4

unsigned int adc_rd=0;

void set_up() {   //Configuration for Pic16F887

  ANSEL = 0x04;     // RRA2 analog input
  ANSELH = 0;      // Rest of the pins set as digital inputs or outputs.
  TRISA = 0x04;
  ADCON0 = 0x81;  // ADC_clock period = 4us, CH0, GO_DONE = 0 and ADON = 1
  ADFM_bit= 1;  // Conversion result is right justified
  C1ON_bit = 0;    // analog comparators off.
  C2ON_bit = 0;
  TRISC2_bit= 0;
  RC2_bit = 0;
}

PWM_Write(unsigned int duty, long PWM_freq) {

    if(duty<1023)  {
    duty = ((float)duty/1023)*(XFREQ/(PWM_freq*T2_Pscale));
    // On reducing //duty = (((float)duty/1023)*(1/PWM_freq)) / ((1/XFREQ) * T2_Pscale);
    DC1B1_bit = duty & 1; //Store the 1st bit
    DC1B0_bit = duty & 2; //Store the 0th bit
    CCPR1L = duty>>2;// Store the remining 8 bit
  }
}

PWM_Init(long PWM_freq) {

    PR2 = (XFREQ/(PWM_freq*4*T2_Pscale)) - 1; 
    //Setting the PR2 formulae using Datasheet // Makes the PWM work in 5KHZ
    CCP1M3_bit = 1; 
    CCP1M2_bit = 1;  //Configure the CCP1 module
    T2CKPS0_bit = 1;
    T2CKPS1_bit = 0;
    TMR2ON_bit = 1; //Configure the Timer module
    TRISC2_bit = 0; // make port pin on C as output
}
void main() {
  set_up();
  PWM_Init(5000);
  while (1) {
    adc_rd = ADC_Read(2);
    delay_ms(5);
    PWM_Write((adc_rd),5000);
    delay_ms(5);
 }
}



